; Simple MIDI note player     *** This version inverts data out of SOUT ***

; XPTR is my assembler macro for loading pointer i.e. LDI high_addr, XPAH ptr, LDI low_addr, XPAL ptr

        org     0880

        xptr    2 $9            ; data area
        xptr    3 $0-1          ; midi routine

        ldi     90              ; 'note on, channel 0' (running status)
        xppc    3               ; send it to MIDI
$3      xptr    1 0B00          ; start of list
$2      ld      @01 (1)         ; get next note in list
        st      01 (2)          ; (preserve for note off)
        jp      $5              ; is valid (00-7F)
        adi     01              ; was it FF 'stop - end of list' ?
        jnz     $3              ; no, repeat list (80-FE)
        ldi     7B              ; 'all notes off'
        xppc    3               ; send it
$4      halt
        jmp     $4              ; loop (until reset)

$5      jz      $6              ; 00 means just silence period
        xppc    3               ; else send note value (01-7F)
        ldi     40              ; default 'on' velocity
        xppc    3               ; send velocity
$6      ld      @01 (1)         ; get duration in 0.05 seconds
        st      00 (2)          ; store as counter
$7      ldi     40
        dly     61              ; delay 0.05 second
        dld     00 (2)
        jnz     $7              ; not expired
        ld      01 (2)          ; else get previous note
        jz      $2              ; (was silence period)
        xppc    3               ; else send note value
        ldi     00              ; with zero velocity = 'note off'
        xppc    3               ; send it
        jmp     $2              ; next in list

$9      defb    00 00           ; counter, last note

$0      xae              ;    7 ; data byte to E register
        ccl              ;    5 ; (CAE requires this done)
        ldi     00       ;   10 ; we need to...
        cae              ;    8 ; invert the data bits
        xae              ;    7 ; store back in E register
        ldi     FF       ;   10 ; start bit b0
        xae              ;    7 ; to send
        sio              ;    5 ; SOUT start bit =1
        xae              ;    7 ; inverted data to send
        ccl              ;    5 ; (this is now effectively dummy)
        ldi     00       ;   10 ; rotating mask
$1      rr               ;    5 ;
        sio              ;    5 ; data bits b0 to b7
        adi     40       ;   11 ; accumulate bits
        jp      $1       ; 9/11 ; until done
        ade              ;    7 ; (dummy) E=00 if SIN always=0
        sio              ;    5 ; SOUT stop bit =0
        xppc    3        ;    7 ;
        jmp     $0       ;   11 ;

